<?php // $Id: act_proc.php,v 1.14 2004/10/11 10:42:42 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) by Mario Gleirscher                         *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

/*
 * Required files:
 * -
 *
 * Benoetigte Variablen (Parameter):
 * sBackaction  - Ruecksprungaction
 * url_data_id  - nur bei update und delete
 * apx_a        - mainaction
 * s_subaction  - subaction
 * b_proc       - datenbankaktion
 * oForm        - Formulardaten
 */

$b_dbsuccess = false;
$s_dbt       = $apx_dbtableprefix.$oForm->dbtable;
$s_id        = $oForm->id_field.'_id';

// alle evtl. nicht existierenden POST-Var. setzen (checkboxen)
// POST-Variablen mit ungueltigen Werten berichtigen
// mit "required" gekennzeichnete Felder auf gueltigen Wert ueberpruefen
reset( $oForm->fields );
while( list( $cur_key, $cur_field ) = each( $oForm->fields ) ) {
    if( $cur_field[ 'ftype' ] == 'checkbox' ) {
        if( !apxIsPost( $cur_field[ 'name' ] ) )
            $_POST[ $cur_field[ 'name' ] ] = 0;
    }
    // Datentypen ueberpruefen und ggf. auf einen Defaultwert setzen
    elseif( $cur_field[ 'vtype' ] == 'int' &&
            $_POST[ $cur_field[ 'name' ] ] == '' ) {
        $_POST[ $cur_field[ 'name' ] ] = $cur_field[ 'default' ];
    }
    
    // Convert 'calc' (and 'c') types into DB decimal format
    if( $apx_decimal_point != '.' && // differing from dot? (assumed as DB default)
    	$cur_field['subftype'] == 'calc' ) { 
    	// is_numeric(trim( $_POST[$cur_field['name']] )) ) { // check for number
	    // convert decimal point if used
		$_POST[$cur_field['name']] = apxNumEuro2Intl(trim( $_POST[$cur_field['name']] ));			
    	// TODO: check whether price fields in db can be of different type e.g. DECIMAL(8,2)
	}

    if( $cur_field[ 'required' ] && empty( $_POST[ $cur_field[ 'name' ] ] ) ) {
        trigger_error( _( "Some required form fields (marked red) are containing no or invalid values." ).
                       '<br /><a href="javascript:history.back()">'.
                       _( "Back" ).' ...</a>',
                       E_USER_WARNING );
        $s_subaction = 'i';
        $b_proc      = 0;
        return;
    }

/*  // Datum darf nie '' sein sondern 'NULL'
    if( $cur_field[ 'ftype' ] == 'date' && $s_subaction != 'd' ) {
        if ( trim( $_POST[ $cur_field[ 'name' ] ] ) == '' )
            $_POST[ $cur_field[ 'name' ] ] = 'NULL';
    }
 */

    if( $cur_field[ 'subftype' ] == 'pw' )
        apxIsPost( $cur_field[ 'name' ].'_chpw', 'b_'.$cur_field[ 'name' ].'_chpw' );
}

if( $s_subaction == 'i' ) {
    // Die groesste _id finden
    $qMax_id    = $apx_dbc->query( "SELECT MAX( $s_id ) AS max_id FROM $s_dbt" );
    $q_maxitems = $apx_dbc->query( "SELECT COUNT( $s_id ) AS maxitems FROM $s_dbt" );

    if( is_object( $qMax_id ) && $qMax_id->rows )
        $max_id = $qMax_id->data[ 0 ][ "max_id" ] + 1;
    else
        $max_id = 0;

    $i_maxitems    = $q_maxitems->data[ 0 ][ "maxitems" ];
    $s_querystring = "INSERT INTO $s_dbt ( $s_id";
    $s_valuestring = "VALUES ( $max_id";

    reset( $oForm->fields );
    while( list( $cur_key, $cur_field ) = each( $oForm->fields ) ) {
        if( $cur_field[ 'ftype' ] != 'label' &&
            $cur_field[ 'subftype' ] != 'pw' ) {

            if( trim( $_POST[ $cur_field[ 'name' ] ] ) == '' ) {
                $s_delimiter = '';
                $_POST[ $cur_field[ 'name' ] ] = 'NULL';
            }
            else
                $s_delimiter = ( $cur_field[ 'vtype' ] != 'int' ? '\'' : '' );

            $s_querystring .= ', '.$cur_field[ 'name' ];
            $s_valuestring .= ', '.$s_delimiter.$_POST[ $cur_field[ 'name' ] ].$s_delimiter;
        }
        else if( $cur_field[ 'subftype' ] == 'pw' ) {
            $s_querystring .= ', '.$cur_field[ 'name' ];
            $s_valuestring .= ', \''.md5( trim( $_POST[ $cur_field[ 'name' ] ] ) ).'\'';
        }
    }

    if( $oForm->editorlog ) {
        $iFirsteditor = $iLasteditor = $apx_auth_editor_id;

        $s_querystring .= ', lastupdated, lasteditor, created, firsteditor ';
        $s_valuestring .= ", '".date( "Y-m-d", time() )."', ".$iLasteditor.", '".
                          date( "Y-m-d", time() )."', ".$iFirsteditor;
    }

    $s_querystring .= ' ) '.$s_valuestring.' )';

    if( $i_maxitems <= $oForm->maxitems ) {
        $b_dbsuccess = $apx_dbc->query( $s_querystring );

        if( $b_dbsuccess ) {
            trigger_error( _( "The database has been updated. The new item has been saved." ).'<br />
              <a href="'.$apx_script.'?apx_a='.$sBackaction.'">'._( "Back to the overall view" ).'</a>', E_USER_NOTICE );

            // Zurueck zum Formular
            $s_subaction = 'u';
            $url_data_id = $max_id;
        }
        else
            trigger_error( $apx_errors[ 24 ].$oForm->msg_dberror.
                           $apx_dbc->error(), E_USER_WARNING );
    }
    else {
        trigger_error( _( "The entry has not been saved. There are too many entries in this database table. Decrease the restrictions or delete some items not used anymore." ), E_USER_WARNING );
    }

    $b_proc = 0;
}
elseif( $s_subaction == 'u' ) {
    $s_querystring = "UPDATE $s_dbt SET ";
    $i_keycount = 0;

    reset( $oForm->fields );
    while( list( $cur_key, $cur_field ) = each( $oForm->fields ) ) {
        if( $cur_field[ 'ftype' ] != 'label' &&
            $cur_field[ 'subftype' ] != 'pw' ) {
            $s_delimiter = ( $cur_field[ 'vtype' ] != 'int' ? '\'' : '' );

            $s_querystring .= ( $i_keycount++ ? ', ' : '' ).
                              $cur_field[ 'name' ].' = '.
                              $s_delimiter.$_POST[ $cur_field[ 'name' ] ].$s_delimiter;
        }
        else if( $cur_field[ 'subftype' ] == 'pw' ) {
            $s_querystring .= ${'b_'.$cur_field[ 'name' ].'_chpw'} ?
                              ', '.$cur_field[ 'name' ]." = '".
                              md5( trim( $_POST[ $cur_field[ 'name' ] ] ) )."' " :
                              '';
        }
    }

    if( $oForm->editorlog ) {
        $iLasteditor = $apx_auth_editor_id;

        $s_querystring .= ", lastupdated = '".date( "Y-m-d", time() ).
                          "', lasteditor = ".$iLasteditor;
    }

    $s_querystring .= " WHERE $s_id = $url_data_id";

    $apx_dbc->query( $s_querystring );

    trigger_error( _( "The item in the database has been updated." ).'<br />
      <a href="'.$apx_script.'?apx_a='.$sBackaction.'">'._( "Back to the overall view" ).'</a>', E_USER_NOTICE );

    $b_proc = 0;
}
elseif( $s_subaction == 'd' ) {
    $apx_dbc->query( "DELETE FROM $s_dbt WHERE $s_id = $url_data_id" );

    trigger_error( _( "The item has been deleted from the database." ).'<br />
      <a href="'.$apx_script.'?apx_a='.$sBackaction.'">'._( "Back to the overall view" ).'</a>', E_USER_NOTICE );
}


?>
