<?php // $Id: act_proc_inquiry.php,v 1.6 2004/10/11 10:42:42 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) 2001-2005 Mario Gleirscher                  *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

// 1. Suche nach bestehenden Kunden mit denselben Daten
if( trim( $_POST[ 'firstname' ] ) == '' ||
    trim( $_POST[ 'lastname' ] ) == '' ||
    trim( $_POST[ 'zip' ] ) == '' ||
    trim( $_POST[ 'place' ] ) == '' ) {
    trigger_error( _( "The form has been sent uncomplete! Please, try it again and take care of filling the red coloured fields." ).
                   '<br /><a href="javascript:history.back()">'._( "Back" ).'</a>',
                   E_USER_WARNING );
    return;
}

$sSearchPattern = "WHERE ".
                  apxDBstrcmp( 'ac.firstname', trim( $_POST[ 'firstname' ] ) ).' AND '.
                  apxDBstrcmp( 'ac.lastname', trim( $_POST[ 'lastname' ] ) ).' AND '.
                  'ac.country_id = '.$_POST[ 'country_id' ].' AND '.
                  apxDBstrcmp( 'ac.zip', trim( $_POST[ 'zip' ] ) ).' AND '.
                  apxDBstrcmp( 'ac.place', trim( $_POST[ 'place' ] ) );

$iRowsPerPage = '--';
$iOffset      = 0;
$i_cus_id     = 0;
$d_now        = date( "'Y-m-d'", time() );

require( $apx_root_path.'qry/qry_customers.php' );

// 2. Kunde eintragen, falls noetig
if( !$iListCount ) {
    $q_max_id = $apx_dbc->query( "
    SELECT MAX( customer_id ) AS max_id FROM {$apx_dbtableprefix}customers
    " );

    if( is_object( $q_max_id ) && $q_max_id->rows )
        $i_cus_id = $q_max_id->data[ 0 ][ "max_id" ] + 1;
    else
        $i_cus_id = 0;

    $apx_dbc->query( "
    INSERT INTO {$apx_dbtableprefix}customers
    ( customer_id, firstname, lastname, address, country_id, zip,
      place, phone, mobile, fax, email, entrytype, created, lastupdated,
      notice )
    VALUES (
    $i_cus_id,
    '{$_POST[ 'firstname' ]}',
    '{$_POST[ 'lastname' ]}',
    '{$_POST[ 'address' ]}',
    {$_POST[ 'country_id' ]},
    '{$_POST[ 'zip' ]}',
    '{$_POST[ 'place' ]}',
    '{$_POST[ 'phone' ]}',
    '{$_POST[ 'mobile' ]}',
    '{$_POST[ 'fax' ]}',
    '{$_POST[ 'email' ]}',
    1, $d_now, $d_now,
    '[APX ANFRAGE: AUTOEINTRAG]' )
    " );
}
elseif( $iListCount == 1 ) {
    $i_cus_id = $qListData->data[ 0 ][ 'customer_id' ];
}
else{
    trigger_error( _( "This identity/customer has already multiple entries in the database. Your inquiry cannot be related unambiguously to one of these customers by only having the information submitted!" ).
                   '<br /><a href="javascript:history.back()">'._( "Back" ).'</a>',
                   E_USER_WARNING );
    return;
}

// 3. Buchung eintragen
$q_max_id = $apx_dbc->query( "
SELECT MAX( booking_id ) AS max_id FROM {$apx_dbtableprefix}bookings
" );

if( is_object( $q_max_id ) && $q_max_id->rows )
    $i_booking_id = $q_max_id->data[ 0 ][ "max_id" ] + 1;
else
    $i_booking_id = 0;

$b_success = $apx_dbc->query( "
INSERT INTO {$apx_dbtableprefix}bookings
( booking_id, customer_id, is_inquiry, room_id, date_begin, date_end, persons, children,
  timeofarrival, notice, created, lastupdated )
VALUES (
$i_booking_id,
$i_cus_id,
1,
{$_POST[ 'room_id' ]},
'{$_POST[ 'date_begin' ]}',
'{$_POST[ 'date_end' ]}',
{$_POST[ 'persons' ]},
{$_POST[ 'children' ]},
{$_POST[ 'timeofarrival' ]},
'{$_POST[ 'notice' ]}',
$d_now, $d_now )
" );

if( $b_success ) {
    trigger_error( _( "Your inquiry has been registred. You will be informed or supplied with a confirmation respectively!" ),
                   E_USER_NOTICE );
}
else {
    trigger_error( _( "Some errors have appeared during the registration of the inquiry. Please, try it again!" ),
                   E_USER_WARNING );
}

?>

