<?php // $Id: dsp_countries.php,v 1.13 2004/10/11 10:42:44 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) 2001-2005 Mario Gleirscher                  *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

require_once( $apx_root_path."act_structs.php" );

// Struktur fuellen
$sSList = new APXSurveyList(
    'countrydb', 'country', '', _( "Country file" ),
    true, true, 'country', 'countries', 'country_id', 'qCountries',
    'qCountryCount'
    );

$sSList->initMessages(
    _( "There is no country data left! Please, add new countries to the database." ),
    _( "Add new country" )
    );

$sSList->addFilterCrit( 'countryname_de', 'fc1', 'str', 'sfilter_crit1', '--' );

$sSList->addColumn( _( 'German country name (D)' ),   's', 'country' );
$sSList->addColumn( _( 'English country name (GB)' ), 's', 'countryname_en' );
$sSList->addColumn( _( 'Int. abb.' ),                 's', 'shortcut' );
$sSList->addColumn( _( 'Prior show' ),                'b', 'priorshow;'._( 'yes;no' ) );
$sSList->addColumn( _( 'Edit' ),                      'e', '' );

require( $apx_root_path.'dsp/dsp_list.php' );

?>

