<?php // $Id: dsp_form_customer.php,v 1.10 2004/10/11 10:42:45 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) by Mario Gleirscher                         *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

/*
 * Required files:
 * - act_structs.php
 * - qry/qry_countries.php
 * - dsp/dsp_form.php
 * - dsp/dsp_bookings.php 
 *
 * Parameter:
 * -
 */

require_once( $apx_root_path."act_structs.php" );

// Struktur fuellen
$oForm = new APXDataForm(
    'customer', 'customerdb', 4, 'customers', 'customer',
    true, '', true, '_ctl', 500
    );

$oForm->initMessages( 'i', _( 'Add new customer' ) );
$oForm->initMessages( 'u', _( 'Change customer data' ) );
$oForm->initMessages( 'd', _( 'Delete customer' ) );

$oForm->addField( 'url_data_id',  'label',    'var',    'int',   0,   0,   0, 'ud'  );
$oForm->addField( 'entrytype',    'select',   'array',  'int',   $apx_std_entrytype,    1,   0, 'apx_entrytypes;n' );
$oForm->addField( 'male',         'radio',    '',       'int',   1,   0,   0, _( '1/male|0/female' ) );
$oForm->addField( 'sex',          'select',   'array',  'int',   0,   1,   0, 'apx_sex;n' );
$oForm->addField( 'title',        'text',     'line',   'str',  '',  10,  30  );
$oForm->addField( 'firstname',    'text',     'line',   'str',  '',  30,  30  );
$oForm->addField( 'lastname',     'text',     'line',   'str',  '',  30,  50  );
$oForm->addField( 'address',      'text',     'line',   'str',  '',  30,  100  );
$oForm->addField( 'country_id',   'select',   'db',     'int',   2,   1,   0,
                  'qCountries;country_id;country;'._( 'No country specified!' ) );
$oForm->addField( 'zip',          'text',     'line',   'str',  '',  10,  15  );
$oForm->addField( 'place',        'text',     'line',   'str',  '',  30,  50  );
$oForm->addField( 'phone',        'text',     'line',   'str',  '',  30,  30  );
$oForm->addField( 'mobile',       'text',     'line',   'str',  '',  30,  30  );
$oForm->addField( 'fax',          'text',     'line',   'str',  '',  30,  30  );
$oForm->addField( 'email',        'text',     'email',  'str',  '',  30,  80  );
$oForm->addField( 'phone2',       'text',     'line',   'str',  '',  30,  30  );
$oForm->addField( 'homepage',     'text',     'url',    'str',  '',  30,  100 );
$oForm->addField( 'im_id',        'text',     'line',   'str',  '',  30,  30  );
$oForm->addField( 'im_type',      'select',   'array',  'int',  '',  1,   0,  'apx_im_types;n' );
$oForm->addField( 'creditcardnr', 'text',     'line',   'str',  '',  30,  30  );
$oForm->addField( 'bankaccount',  'text',     'line',   'str',  '',  30,  40  );

$oForm->addField( 'birthdate',    'date',     'del',    'noUTS', '1950-01-01',  10,  12,  '' );
$oForm->addField( 'job',          'text',     'line',   'str',  '',  30,  50  );
$oForm->addField( 'nickname',     'text',     'line',   'str',  '',  30,  30  );
$oForm->addField( 'passportnr',   'text',     'line',   'str',  '',  30,  100 );
$oForm->addField( 'nationality',  'select',   'db',     'int',   2,   1,   0,
                  'qCountries;country_id;country;'._( 'No country specified!' ) );
$oForm->addField( 'notice',       'text',     'area',   'str',  '',  4,   85  );

$oForm->setJavascript( '
    var test1;

    test1 = notice.value.indexOf(\'\\\'\') == -1 &&
            notice.value.indexOf(\'\\n\') == -1 &&
            notice.value.indexOf(\'"\') == -1;

    if ( !test1 )
        window.alert( \''._( 'Some characters in the field "Notice" are not accepted!' ).'\' );

    return test1;
' );


// Zusaetzliche Abfragen aus anderen Tabellen:
// Laenderdaten holen
require( $apx_root_path.'qry/qry_countries.php' );

require( $apx_root_path.'dsp/dsp_form.php' );

// Buchungsliste anzeigen, wenn Gaesteeintrag schon erstellt ist bzw. wenn
// Eintragstyp = Kunde
if( $s_subaction != 'i' && $qr_entrytype == 1 ) {
    $_GET[ 'backaction' ] = $sBackaction;
    include( "dsp_bookings.php" );
}

?>




