<?php // $Id: dsp_bookings.php,v 1.4 2004/10/11 10:42:44 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) by Mario Gleirscher                         *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

/*
 * Required files:
 * - act_structs.php
 *
 * Parameter:
 */

require_once( $apx_root_path."act_structs.php" );

// Struktur fuellen
$sSList = new APXSurveyList(
    'bk_entrydb', 'bk_entry', '', _( "Account entry file" ),
    false,
    false, '', 'bk_entries', 'entry_id', 'qBKEntryData' );

$sSList->initMessages(
    _( "There is no account entry data available! Please, create new entries in the accounting entries menu." ),
    _( "Insert a new entry into this account." )
    );

$sSList->enableMultiDel( 'bk_entries' );

$sSList->addColumn( _( 'Entrynr.' ),           's', 'custom_id' );
$sSList->addColumn( _( 'Date' ),               'd', 'entry_date' );
$sSList->addColumn( _( 'Accountnr.' ),         's', 'account_custom_id' );
$sSList->addColumn( _( 'Description' ),        's', 'description' );
$sSList->addColumn( _( 'Amount' ),             'w', 'amount' );
$sSList->addColumn( _( 'Active' ),             'b', 'active' );
// $sSList->addColumn( _( 'Actions' ),         'i',  $apx_root_path.'dsp/dsp_bk_accounts_col_1.php', 'apx_controlbg' );
$sSList->addColumn( _( 'Edit' ),               'e', '' );

require( $apx_root_path.'dsp/dsp_list.php' );

?>


