<?php // $Id: dsp_form.php,v 1.10 2004/10/11 10:42:45 mario Exp $

/**************************************************************************
 * mg.applanix, Copyright (C) by Mario Gleirscher                         *
 * mg.applanix comes with ABSOLUTELY NO WARRANTY; This is free software,  *
 * and you are welcome to redistribute it under certain conditions;       *
 * view the file COPYING for details.                                     *
 **************************************************************************/

// Parameter ueberpruefen
apxIsGet( 'backaction', 'sBackaction', $oForm->url_listaction );
apxIsGet( 'id', 'url_data_id', 'NULL' );
apxIsGet( 'do', 's_subaction', 'i' );
apxIsGet( 'proc', 'b_proc' );

// Zulaessige Aktionen pruefen, sonst abbrechen
if( strstr( $oForm->disabled_actions, $s_subaction ) ) {
    trigger_error( _( "This action is not allowed with this form!" ),
                   E_USER_WARNING );
    return;
}

// Wenn proc=1, dann Datenbankaktion ausfuehren
if( $b_proc ) {
    require( $apx_root_path.'act/act_proc.php' );
}

// (A): Beim aktiven Loeschen kein Formular mehr anzeigen
if( !( $s_subaction == 'd' && $b_proc ) ):

if( $s_subaction != 'i' && $url_data_id != 'NULL' ) {
    require( $apx_root_path.'qry/qry_form.php' );
}

// Formularfeldwerte aus DB lesen
reset( $oForm->fields );
while( list( $cur_key, $cur_field ) = each( $oForm->fields ) ) {
    if( $s_subaction != 'i' && $url_data_id != 'NULL' )
        $cur_datafield = $qFormData->data[ 0 ][ $cur_field[ 'name' ] ];
    else
        $cur_datafield = $cur_field[ 'default' ];

    if( $cur_field[ 'vtype' ] == 'date' ) {
        // Wenn Datum leer 'NULL' in Datenbank
        if( trim( $cur_datafield ) == '' || trim( $cur_datafield ) == 'NULL' )
            $cur_datafield = $cur_field[ 'default' ];

        if( $s_subaction == 'i' )   // als Defaultwert per UNIX-TIMESTAMP
            ${'qr_'.$cur_field[ 'name' ]} = $cur_datafield;
        else                        // aus Datenbank im SQL-DATE-Format
            ${'qr_'.$cur_field[ 'name' ]} = strtotime( $cur_datafield );
    }
    // kein UNIX Timestamp z. B. bei Geburtstagen
    else if( $cur_field[ 'vtype' ] == 'noUTS' ) {
        // Wenn Datum leer 'NULL' in Datenbank
        if( trim( $cur_datafield ) == '' || trim( $cur_datafield ) == 'NULL' )
            $cur_datafield = $cur_field[ 'default' ];

        ${'qr_'.$cur_field[ 'name' ]} = substr( $cur_datafield, 0, 10 );
    }
    else
        ${'qr_'.$cur_field[ 'name' ]} = $cur_datafield;
}

// Eintragslogging
if( $oForm->editorlog ) {
    if( $s_subaction != 'i' ) {
        if( trim( $qFormData->data[ 0 ][ "lastupdated" ] ) != '' )
            $qr_lastupdated = strtotime( $qFormData->data[ 0 ][ "lastupdated" ] );
        else
            $qr_lastupdated = 0;

        if( trim( $qFormData->data[ 0 ][ "created" ] ) != '' )
            $qr_created     = strtotime( $qFormData->data[ 0 ][ "created" ] );
        else
            $qr_created     = 0;

        $qr_lasteditor  = $qFormData->data[ 0 ][ "lasteditor" ];
        $qr_firsteditor = $qFormData->data[ 0 ][ "firsteditor" ];
    }
    else {
        $qr_lastupdated = time();
        $qr_lasteditor  = '';
        $qr_created     = time();
        $qr_firsteditor = '';
    }
}

// Formularevaluierung aktivieren?
if( $oForm->checkform && $s_subaction != 'd' ) {
    echo "\n<script language=\"JavaScript1.2\">\n<!--\n".
         "function apxEvalForm() {\n".
         "with( window.document.".$oForm->form_name." ) {\n".
         $oForm->javascript.
         "\n}\nreturn true;\n}\n//-->\n</script>";
}

// Colspan
$b_showeditorlog = $oForm->editorlog && $s_subaction != 'i';
$i_formcolspan   = $oForm->columns - ( $b_showeditorlog ? 2 : 1 );

?>

<form method="POST" name="<?php echo $oForm->form_name ?>"
<?php
if( !empty( $oForm->form_action ) )
    echo ' action="'.$oForm->form_action.'" ';
else
    echo ' action="'.$apx_script.'?apx_a='.$oForm->form_name.'&do='.$s_subaction.'&proc=1'.
         ( $s_subaction != 'i' ? '&id='.$url_data_id : '' ).
         '&backaction='.$sBackaction.'" ';

if( $oForm->checkform && $s_subaction != 'd' )
    echo 'onSubmit="return apxEvalForm()" ';
?>
>

<?php // nicht verwendete info apx_redirectiondata evtl. fuer zukuenftige Versionen ?>
<input type="hidden" name="apx_redirectiondata"
       value="<?php echo $apx_script.'?'.$apx_query_string ?>">

<table class="apx_form">
<tr><td class="apx_headerbg" colspan="<?php echo $i_formcolspan ?>">
<span class="mgsubtitle"><?php echo $oForm->actions[ $s_subaction ][ 'headline' ] ?>
</span>
</td>

<?php
if( $oForm->columns < 3 || !$b_showeditorlog )
    echo '<td class="apx_controlbg">';

if( $b_showeditorlog ) {
    if( $oForm->columns >= 3 )
        echo '<td class="apx_mainbg" nowrap="yes">';

    echo '<span class="mgtxtsmall">'._( 'Created: ' );

    if( $qr_created )
        echo date( $apx_dateformat, $qr_created ).' ('.
             ( trim( $qr_firsteditor ) != '' ? $qr_firsteditor : _( 'Unknown' ) ).')';
    else
        echo _( 'Unknown' );

    echo '<br />'._( 'Last change: ' );

    if( $qr_lastupdated )
        echo date( $apx_dateformat, $qr_lastupdated ).' ('.
             ( trim( $qr_lasteditor ) != '' ? $qr_lasteditor : _( 'Unknown' ) ).')';
    else
        echo _( 'Unknown' );

    echo '</span>';

    if( $oForm->columns >= 3 )
        echo '</td>';
}

if( $oForm->columns >= 3 && $b_showeditorlog )
    echo '<td class="apx_controlbg">';

if( $s_subaction == 'u' || $s_subaction == 'd' ) {
    if( $oForm->cusctl_script != '' ) {
        require( $apx_root_path.'dsp/dsp_form_'.
                 $oForm->form_name.$oForm->cusctl_script.'.php' );
    }

    if( $oForm->delbutton )
        echo '<a href="'.$apx_script.'?apx_a='.$oForm->form_name.'&do=d&id='.$url_data_id.
             '"><img onMouseover="return dispStatus(\''.$oForm->actions[ 'd' ][ 'headline' ].'\')"
             onMouseout="return dispStatus(\'\')" title="'.$oForm->actions[ 'd' ][ 'headline' ].'" src="'.
             $apx_imgpath.'sym_delete.gif" ></a>&nbsp;&nbsp;&nbsp;&nbsp;';
}
?>

<a href="<?php echo $apx_script ?>?apx_a=<?php echo $sBackaction ?>">
<img onMouseover="return dispStatus('<?php echo _( "Back" ) ?>')"
     onMouseout="return dispStatus('')"
     title="<?php echo _( "Back" ) ?>"
     src="<?php echo $apx_imgpath ?>sym_left.gif" ></a></td>
</tr>

<?php

// Template oeffnen
$s_tmplfile = $apx_root_path.'dsp/dsp_form_'.$oForm->form_name.'.tmpl.php';

if( !file_exists( $s_tmplfile ) )
    trigger_error( $apx_errors[ 25 ], E_USER_WARNING );

$h_file = fopen( $s_tmplfile, "r" );
$s_tmpl = fread( $h_file, filesize( $s_tmplfile ) );
fclose( $h_file );

// template Localisation-Sprachuebersetzung durchfuehren (l10n)
while( preg_match( "/<\?=\s*_\(\s*\"(.*)\"\s*\)\s*\?>/i", $s_tmpl, $aMatches ) ) {
    $s_tmpl = preg_replace( "/<\?=\s*_\(\s*\"(.*)\"\s*\)\s*\?>/i",
              _( $aMatches[ 1 ] ), $s_tmpl, 1 );
}

// restliche php-bereiche loeschen
$s_tmpl = preg_replace( "/<\?.*\?>/i", '', $s_tmpl );
$aMatches = array();


// Formulargenerator

// Formulartemplate holen, zeilenweise durchsuchen und durch ersetzen
// Formularelemente werden durch <apx_formfield name="<feldname>" /> gekennzeichnet
while( preg_match( "/<apx_formfield\s*name=\"(.*)\"\s*\/?>/i", $s_tmpl, $aMatches ) ) {

    $cur_field = $oForm->fields[ $aMatches[ 1 ] ];
    $s_curexchange = '';

    if( $cur_field[ 'required' ] )
        $s_fieldstyle = ' class="apx_required"';
    else
        $s_fieldstyle = '';

    switch( $cur_field[ 'ftype' ] ) {
    case 'select':  // subtypes array, count, db
        $s_curexchange = '<select '.$s_fieldstyle.' name="'.$cur_field[ 'name' ].
                         '" size="'.$cur_field[ 'size' ].'">';
        if( $cur_field[ 'subftype' ] == 'array' ) {
            // Dataset besteht aus: Name des Feldes, Index in 2. Dim. (n fuer keinen)
            list( $a_array, $i_2dindex ) = explode( ';', $cur_field[ 'dataset' ] );

            reset( $$a_array );
            while( list( $cur_key, $cur_val ) = each( $$a_array ) ) {
                $s_curexchange .= '<option value="'.$cur_key.'" '.
                                  ( ${'qr_'.$cur_field[ 'name' ]} == $cur_key ? 'selected' : '' ).
                                  '>'.( $i_2dindex == 'n' ? $cur_val : $cur_val[ $i_2dindex ]).'</option>';
            }
        }
        else if( $cur_field[ 'subftype' ] == 'count' ) {
            $cur_selectdata = explode( ';', $cur_field[ 'dataset' ] );
            for( $i = $cur_selectdata[ 0 ]; $i <= $cur_selectdata[ 1 ]; $i++ )
                $s_curexchange .= '<option value="'.$i.'" '.
                     ( ${'qr_'.$cur_field[ 'name' ]} == $i ? 'selected' : '' )
                     .'>'.$i.'</option>'."\n\r";
        }
        else if( $cur_field[ 'subftype' ] == 'db' ) { // Listendaten aus Datenbanktabelle
            list( $s_dbquery, $s_idfield, $s_textfield, $s_emptystr ) =
                explode( ';', $cur_field[ 'dataset' ] );
            if( is_object( $$s_dbquery ) ) {
                foreach( ${$s_dbquery}->data as $rowData ) {
                    $cur_text = trim( $rowData[ $s_textfield ] ) != '' ?
                                $rowData[ $s_textfield ] : $s_emptystr;
                    $s_curexchange .= '<option value="'.$rowData[ $s_idfield ].'" '.
                         ( ${'qr_'.$cur_field[ 'name' ]} == $rowData[ $s_idfield ] ? 'selected' : '' )
                         .'>'.$cur_text.'</option>'."\n\r";
                }
            }
        }
        $s_curexchange .= '</select>';
        break;

    case 'text': {  // subtypes line, url, calc, pw (password), area, email
        switch( $cur_field[ 'subftype' ] ) {
        case 'line':
            $s_curexchange = '<input '.$s_fieldstyle.' type="text" name="'.$cur_field[ 'name' ].
                             '" size="'.$cur_field[ 'size' ].
                             '" maxlength="'.$cur_field[ 'maxlength' ].
                             '" value="'.${'qr_'.$cur_field[ 'name' ]}.'" />';
            break;
        case 'email':
            $s_curexchange = '<input '.$s_fieldstyle.' type="text" name="'.$cur_field[ 'name' ].
                             '" size="'.$cur_field[ 'size' ].
                             '" maxlength="'.$cur_field[ 'maxlength' ].
                             '" value="'.${'qr_'.$cur_field[ 'name' ]}.'" />';
            if ( $s_subaction != 'i' && trim( ${'qr_'.$cur_field[ 'name' ]} ) != '' ) {
                $sCusMailHref = apxCreateMailURL( trim( ${'qr_'.$cur_field[ 'name' ]} ), $url_data_id, $apx_script,
                                $apx_use_extern_mailer, $apx_imgpath,
                                false, '', '', $apx_user_stdsubject, false,
                                '&backaction='.$sBackaction );

                $s_curexchange .= "<a href=\"$sCusMailHref\"><img src=\"".
                                  $apx_imgpath."sym_email.gif\" title=\"Email senden ...\" align=\"top\" border=\"0\"></a>";
            }
            break;

        case 'calc':  // currency field, if dataset = c
            // reconvert with numberformat (PHP) or http://dev.mysql.com/doc/refman/5.0/en/miscellaneous-functions.html (MySQL)
            $iTmpNumber = number_format( ${'qr_'.$cur_field[ 'name' ]}, 2, 
            	$apx_decimal_point, $apx_thousands_sep );
            $s_curexchange = '<a href="javascript:openwindow( \''.$apx_url.
                             'dsp_calculator.php?form='.$oForm->form_name.
                             '&field='.$cur_field[ 'name' ].'&result='.$iTmpNumber.
                             '\', \'calculator\', \'height='.$iComHeight.',width='.$iComWidth.
                             '\' );"><img title="Taschenrechner" src="'.$apx_imgpath.'sym_calc.gif" align="top"></a> '.
                             '<input '.$s_fieldstyle.' type="text" name="'.$cur_field[ 'name' ].
                             '" size="'.$cur_field[ 'size' ].
                             '" maxlength="'.$cur_field[ 'maxlength' ].
                             '" value="'.$iTmpNumber.
                             '" /> '.
                             ( $cur_field[ 'dataset' ] == 'c' ? $apx_curstring : '' ).' ';
            break;

        case 'url':
            $s_curexchange = '<input '.$s_fieldstyle.' type="text" name="'.$cur_field[ 'name' ].
                             '" size="'.$cur_field[ 'size' ].
                             '" maxlength="'.$cur_field[ 'maxlength' ].
                             '" value="'.${'qr_'.$cur_field[ 'name' ]}.'" />';
            if ( trim( ${'qr_'.$cur_field[ 'name' ]} ) != '' ) {
                $s_curexchange .= '<a href="'.${'qr_'.$cur_field[ 'name' ]}.'" target="_blank">'.
                                  '<img src="'.$apx_imgpath.'sym_homepage.gif" title="'.
                                  _( "Visit homepage ..." ).'" '.
                                  'align="top" border="0"></a>';
            }
            break;

        case 'area':
            $s_curexchange = '<textarea '.$s_fieldstyle.' rows="'.$cur_field[ 'size' ].
                             '" cols="'.$cur_field[ 'maxlength' ].
                             '" name="'.$cur_field[ 'name' ].
                             '" >'.${'qr_'.$cur_field[ 'name' ]}.'</textarea>
                             <a href="javascript:empty_formfield(document.'.
                             $oForm->form_name.'.'.$cur_field[ 'name' ].');">
                             <img title="'._( "Empty field" ).'" src="'.$apx_imgpath.
                             'sym_delete.gif" align="top" />';
            break;

        case 'pw':
            $s_curexchange = '<input '.$s_fieldstyle.' type="password" name="'.$cur_field[ 'name' ].
                             '" size="'.$cur_field[ 'size' ].
                             '" maxlength="'.$cur_field[ 'maxlength' ].
                             '" value="'.${'qr_'.$cur_field[ 'name' ]}.'" /><br />'.
                             '<input '.$s_fieldstyle.' type="password" name="'.$cur_field[ 'name' ].
                             '_eval" size="'.$cur_field[ 'size' ].
                             '" maxlength="'.$cur_field[ 'maxlength' ].
                             '" value="'.${'qr_'.$cur_field[ 'name' ]}.'" />';

            if( $s_subaction == 'u' )
                $s_curexchange .= '<br /><input '.$s_fieldstyle.' type="checkbox" name="'.
                                  $cur_field[ 'name' ].
                                  '_chpw" value="1" /> '._( "Change password" );
            break;
        default:
            $s_curexchange = '[Formularfeld (Subtyp) ungueltig!]';
        }
        }
        break;
    case 'date':  // Subtyp del fuer Datumsfeld loeschen
        $s_curexchange = '<a href="javascript:openwindow( \''.
                         $apx_url.'dsp_calendar.php?form='.$oForm->form_name.'&field='.$cur_field[ 'name' ];

        if( $cur_field[ 'vtype' ] != 'noUTS' )
            $s_curexchange .= '&month='.date( 'm&\y\e\a\r=Y', ${'qr_'.$cur_field[ 'name' ]} );

        $s_curexchange .= '\', \'calendar\', \'height='.$iCalHeight.',width='.$iCalWidth.'\' );">'.
                         '<img title="'._( "Choose date" ).'" src="'.$apx_imgpath.'sym_date.gif" align="top" /></a> '.
                         '<input '.$s_fieldstyle.' type="text" name="'.$cur_field[ 'name' ].
                         '" size="'.$cur_field[ 'size' ].'" maxlength="'.$cur_field[ 'maxlength' ].
                         '" value="';

        if( !( $cur_field[ 'subftype' ] == 'del' && $s_subaction == 'i' ) ) {
            if( $cur_field[ 'vtype' ] == 'noUTS' )
                $s_curexchange .= ${'qr_'.$cur_field[ 'name' ]};
            else
                $s_curexchange .= date( "Y-m-d", ${'qr_'.$cur_field[ 'name' ]} );
        }

        $s_curexchange .= '" readonly />';

        if( $cur_field[ 'subftype' ] == 'del' ) {
            $s_curexchange .= '<a href="javascript:empty_formfield(document.'.
                              $oForm->form_name.'.'.$cur_field[ 'name' ].');">
                              <img title="'._( "Empty field" ).'" src="'.$apx_imgpath.
                              'sym_delete.gif" align="top" />';
        }
        break;

    case 'radio':  // Subtyp lbr fuer Zeilenumbruch nach jeder Option
        $a_radiofields = explode( '|', $cur_field[ 'dataset' ] );
        while( $a_curfield = each( $a_radiofields ) ) {
            list( $cur_val, $cur_text ) = explode( '/', $a_curfield[ 1 ] );
            $s_curexchange .= '<input '.$s_fieldstyle.' type="radio" name="'.$cur_field[ 'name' ].
                 '" value="'.$cur_val.'" '.
                 ( strval( ${'qr_'.$cur_field[ 'name' ]} ) == strval( $cur_val ) ? 'checked="checked"' : '' ).
                 ' />'.$cur_text.
                 ( $cur_field[ 'subftype' ] == 'lbr' ? '<br />' : ' ' );
        }
        break;

    case 'checkbox':
        $s_curexchange = '<input '.$s_fieldstyle.' type="checkbox" name="'.$cur_field[ 'name' ].
                         '" value="'.$cur_field[ 'dataset' ].
                         '" '.( ${'qr_'.$cur_field[ 'name' ]} == $cur_field[ 'dataset' ] ? 'checked' : '' ).' />';
        break;

    case 'label': // subtypen db, var, imm
        if( strstr( $cur_field[ 'dataset' ], $s_subaction ) ) {
            if( $cur_field[ 'subftype' ] == 'db' )          // Wert eines Datenbankfeldes
                $s_curexchange = ${'qr_'.$cur_field[ 'name' ]};
            else if ( $cur_field[ 'subftype' ] == 'imm' )   // direkter Wert
                $s_curexchange = $cur_field[ 'default' ];
            else if ( $cur_field[ 'subftype' ] == 'var' )   // Wert einer PHP Variable
                $s_curexchange = ${$cur_field[ 'name' ]};
            else if ( $cur_field[ 'subftype' ] == 'script' ) { // Skript laufen lassen
                require( $apx_root_path.'dsp/'.$cur_field[ 'default' ].".php" );
            }
        }
        break;

    case 'hidden':
        $s_curexchange = '<input '.$s_fieldstyle.' type="hidden" name="'.$cur_field[ 'name' ].
                         '" value="'.${'qr_'.$cur_field[ 'name' ]}.'" />';
        break;

    default:
        $s_curexchange = '[Formularfeld ungueltig!]';
    }

    // Entsprechendes Feld ersetzen
    $s_tmpl = preg_replace( "/<apx_formfield\s*name=\"".$aMatches[ 1 ]."\"\s*\/?>/i",
                            $s_curexchange, $s_tmpl );
}

echo $s_tmpl;

?>

<tr>
<td class="apx_controlbg" colspan="<?php echo $oForm->columns ?>">
    <span class="mgtxt">
    <?php echo _( "(Red coloured fields have to be filled!)" ) ?>
    </span>
    <input
    <?php if ( $s_subaction == 'd' ) echo( 'class="apx_delete"' ); ?>
    type="submit" value="<?php echo $oForm->actions[ $s_subaction ][ 'button' ] ?>" name="submit" />
    <input type="reset" value="<?php echo _( "Reset form" ) ?>" name="reset" />
</td>
</tr>

</table>
</form>

<?php endif; // (A) ?>
